routes/web.php
<?php

use App\Http\Controllers\AdminController;
use App\Http\Controllers\AdminPermissionController;
use App\Http\Controllers\articlesController;
use App\Http\Controllers\AuthorAuthController;
use App\Http\Controllers\Cms\Auth\LoginController as AuthLoginController;
use App\Http\Controllers\AuthorAuthControole;
use App\Http\Controllers\authorController;
use App\Http\Controllers\categoryController;
use App\Http\Controllers\Cms\Auth\LoginController;
use App\Http\Controllers\Cms\HomeController as CmsHomeController;
use App\Http\Controllers\commentController;
use App\Http\Controllers\contactRequestController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\RolePermissionController;
use App\Http\Controllers\SearchConrtoller;
use App\Http\Controllers\settingController;
use App\Http\Controllers\UserAuthController;
use App\Http\Controllers\UserController;
use App\Models\ContactRequest;
use GuzzleHttp\Middleware;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [HomeController::class,'index'])->name('home');

Route::get('/blog/{id}',  [HomeController::class,'show'])
->name('home-article');

Route::get('/author/{id}',  [HomeController::class,'showAuthor'])
->name('home-author');
Route::get('/category/{id}',  [HomeController::class,'showCategory'])
->name('home-category');

Route::post('/blog/{id}/comment',[HomeController::class,'StorCommment'])->name('comments-user')->middleware('auth:user');

// Route::get('/employee',[SearchConrtoller::class,'index']);
Route::post('/search',[SearchConrtoller::class,'showSearch'])->name('search');

// Route::prefix('cms/admin')->name('cms.')->middleware('guest:admin')->group(function(){
//     Route::get('login',[LoginController::class,'showLoginForm'])->name('login');
//     Route::post('login',[LoginController::class,'login'])->name('login');
//     // Auth::routes();
// });



Route::prefix('cms/author')->middleware('guest:author')->group(function () {
    Route::get('login', [AuthorAuthController::class, 'showLogin'])->name('auth-author.login.view');
    Route::post('login', [AuthorAuthController::class, 'login'])->name('auth-author.login');
});



Route::prefix('user')->middleware('guest:user')->group(function () {
    Route::get('login', [UserAuthController::class, 'showLogin'])->name('auth-user.login.view');
    Route::post('login', [UserAuthController::class, 'login'])->name('auth-user.login');
});




Route::get('cms/dashboard',[CmsHomeController::class,'index'])->name('cms.dashboard')
->middleware('auth:admin,author');




Route::prefix('cms/admin')->name('admin.')->middleware('guest:admin')->group(function(){
    Route::get('login',[AuthLoginController::class,'showLoginForm'])->name('auth.login.view');
    Route::post('login',[AuthLoginController::class,'login'])->name('login');
    // Auth::routes();
});



Route::get('logout', [UserAuthController::class, 'logout'])->name('auth-user.logout')->middleware('auth:user');




Route::prefix('cms')->middleware('auth:admin,author')->group(function(){
Route::resource('admins', AdminController::class);
// Route::view('', 'cms.dashboard')->name('cms.dashboard');
Route::resource('contacts', contactRequestController::class);
Route::resource('comments', commentController::class);


Route::resource('roles', RoleController::class);
Route::resource('permissions', PermissionController::class);

Route::resource('admins.permissions', AdminPermissionController::class);
Route::resource('role.permissions', RolePermissionController::class);

Route::resource('settings', settingController::class)->only(['index','store']);
Route::resource('users', UserController::class);
Route::resource('authors', authorController::class);
Route::resource('categories', categoryController::class);
Route::resource('articles', articlesController::class);


Route::get('edit-password', [AuthorAuthController::class, 'editPassword'])->name('auth.edit-password');
Route::put('update-password', [AuthorAuthController::class, 'updatePassword'])->name('auth.update-password');

Route::get('author/logout', [AuthorAuthController::class, 'logout'])->name('auth-author.logout');
Route::get('logout', [AuthLoginController::class, 'logout'])->name('auth.logout');



});
Route::view('lsl', 'cms.search.index');


// Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Http/Controllers/Cms/HomeController.php
<?php

namespace App\Http\Controllers\Cms;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('cms.dashboard');

    }
}

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Spatie\Permission\Models\Role;

class RoleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $roles = Role::withCount('permissions')->paginate(10);
        return response()->view('cms.spatie.roles.index', ['roles' => $roles]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return response()->view('cms.spatie.roles.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator($request->all(), [
            'guard' => 'required|string|in:admin,user',
            'name' => 'required|string|min:3'
        ]);

        if (!$validator->fails()) {
            $role = new Role();
            $role->name = $request->get('name');
            $role->guard_name = $request->get('guard');
            $isSaved = $role->save();
            return response()->json(['message' => $isSaved ? 'Role created succssefully' : "Failed to create roles"], $isSaved ? 200 : 400);
        } else {
            return response()->json(['message' => 'Please check required data'], 400);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $role = Role::findById($id, 'admin');
        return response()->view('cms.spatie.roles.edit', ['role' => $role]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $validator = Validator($request->all(), [
            'guard' => 'required|string|in:admin,user',
            'name' => 'required|string|min:3'
        ]);

        if (!$validator->fails()) {
            $role = Role::findOrFail($id);
            $role->name = $request->get('name');
            $role->guard_name = $request->get('guard');
            $isSaved = $role->save();
            return response()->json(['message' => $isSaved ? 'Role updated succssefully' : "Failed to update roles"], $isSaved ? 200 : 400);
        } else {
            return response()->json(['message' => 'Please check required data'], 400);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $isDeleted = Role::destroy($id);
        if ($isDeleted) {
            return response()->json(['title' => 'Deleted!', 'message' => 'Role Deleted Successfully', 'icon' => 'success'], 200);
        } else {
            return response()->json(['title' => 'Failed!', 'message' => 'Delete role failed', 'icon' => 'error'], 400);
        }
    }
}

resources/views/cms/admin/create.blade.php
@extends('cms.parent')

@section('title','Create Admin')
@section('page-name','Create Admin')
@section('main-page','Admins')
@section('sub-page','Create Admin')

@section('styles')

<!-- Toastr -->
<link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">


@endsection

@section('content')
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Create Admin</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form role="form" id="create_form" action="{{ route('admins.store') }}" method="post" >
                {{-- @csrf --}}
                <div class="card-body">

                <div class="form-grup">





                  <div class="form-group">
                    <label for="first_name">Name</label>
                    <input type="text" class="form-control" id="name" name="name" placeholder="Enter name"  required>
                    {{-- minlength="3" --}}
                </div>

                  <div class="form-group">
                    <label for="email">Email</label>
                    <input type="email" class="form-control" id="email" name="email" placeholder="Enter Email">
                  </div>
                  <div class="form-group">
                    <label for="mobile">Mobile</label>
                    <input type="tel" class="form-control" id="mobile" name="mobile" placeholder="Enter Mobile">
                  </div>

                  <div class="form-group">
                    <label for="first_name">Password</label>
                    <input type="text" class="form-control" id="password" name="password" placeholder="Enter Password">
                  </div>

                  <div class="form-group">
                    <label for="first_name">Status</label>
                    <input type="text" class="form-control" id="status" name="status" placeholder="Enter Status">
                  </div>

                  <div class="form-group">
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="male" value="M"  name="gender">
                      <label for="male" class="custom-control-label">Male</label>
                    </div>
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="female" value="F" name="gender">
                      <label for="female" class="custom-control-label">Female</label>
                    </div>
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
          <!--/.col (left) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('scripts')
 <!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>

<!-- Toastr -->
<script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>


    <script>
        //  $('#create_form').validate();
        $('#create_form').submit(function(e){
            e.preventDefault();

            var data = new FormData(this);

            axios.post('{{ route('admins.store') }}',data)
            .then(function (response) {
                console.log(response);
                document.getElementById('create_form').reset();
                showToaster(response.data.message, true);
            })
            .catch(function (error) {
                console.log(error.response);
                showToaster(error.response.data.message, false);
            });
        });

        function showToaster(message, status){
            if(status){
                toastr.success(message);
            }else{
                toastr.error(message);
            }
        }
    </script>

@endsection

resources/views/cms/admin/edit.blade.php
@extends('cms.parent')

@section('title','Create Admin')
@section('page-name','Create Admin')
@section('main-page','Admins')
@section('sub-page','Create Admin')

@section('styles')

<!-- Toastr -->



@endsection

@section('content')
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-12">
            <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">Edit Admin</h3>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form role="form" id="edit_form" action="{{ route('admins.update' , $admin) }}" method="post" >
                @csrf
                @method('PUT')
                <div class="card-body">

                <div class="form-grup">





                  <div class="form-group">
                    <label for="first_name">Name</label>
                    <input type="text" class="form-control" id="name" value="{{ $admin->name }}" name="name" placeholder="Enter name"  required>
                    {{-- minlength="3" --}}
                </div>

                  <div class="form-group">
                    <label for="email">Email</label>
                    <input type="email" class="form-control" id="email" name="email" value="{{ $admin->email }}" placeholder="Enter Email">
                  </div>
                  <div class="form-group">
                    <label for="mobile">Mobile</label>
                    <input type="tel" class="form-control" id="mobile" name="mobile" value="{{$admin->mobile  }}" placeholder="Enter Mobile">
                  </div>



                  <div class="form-group">
                    <label for="first_name">Status</label>
                    <input type="text" class="form-control" id="status" name="status" value="{{ $admin->status }}" placeholder="Enter Status">
                  </div>

                  <div class="form-group">
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="male" value="M"  name="gender"
                      @if($admin->gender == 'M') checked @endif
                      >
                      <label for="male" class="custom-control-label">Male</label>
                    </div>
                    <div class="custom-control custom-radio">
                      <input class="custom-control-input" type="radio" id="female" value="F" name="gender"
                      @if($admin->gender == 'F') checked @endif
                      >
                      <label for="female" class="custom-control-label">Female</label>
                    </div>
                  </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Save</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
          <!--/.col (left) -->
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('scripts')
 <!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>

<!-- Toastr -->


    <script>
        //  $('#create_form').validate();
        $('#edit_form').submit(function(e){
            e.preventDefault();

            var data = new FormData(this);

            axios.post('{{ route('admins.update',$admin) }}',data)
            .then(function (response) {
                console.log(response);
                showToaster(response.data.message, true);
            })
            .catch(function (error) {
                console.log(error.response);
                showToaster(error.response.data.message, false);
            });
        });


    </script>

@endsection

resources/views/cms/admin/index-permissions.blade.php
@extends('cms.parent')

@section('title','Cities')
@section('page-name','Index Cities')
@section('main-page','Cities')
@section('sub-page','Index')

@section('styles')
    <!-- Toastr -->
  <link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">
    <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
    <!-- iCheck for checkboxes and radio inputs -->
  <link rel="stylesheet" href="{{ asset('cms/plugins/icheck-bootstrap/icheck-bootstrap.min.css') }}">
@endsection

@section('content')
    <section class="content">
      <div class="container-fluid">
        <!-- /.row -->
        <div class="row">
          <div class="col-12">
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">Cities</h3>

                <div class="card-tools">
                  <div class="input-group input-group-sm" style="width: 150px;">
                    <input type="text" name="table_search" class="form-control float-right" placeholder="Search">

                    <div class="input-group-append">
                      <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive p-0">
                <table class="table table-hover table-bordered text-nowrap">
                  <thead>
                    <tr>
                      <th>#</th>
                      <th>Name</th>
                      <th>Guard</th>
                      <th>Status</th>
                    </tr>
                  </thead>
                  <tbody>
                      @foreach ($permissions as $permission)
                        <tr>
                            <td>{{ $permission->id }}</td>
                            <td>{{ $permission->name }}</td>
                            <td><span>{{ $permission->guard_name }}</span></td>
                            <td>
                                <div class="icheck-success d-inline">
                                    <input type="checkbox" @if($permission->is_active) checked @endif
                                     onclick="store({{ $adminId }}, {{ $permission->id }})" id="permission_{{ $permission->id }}">
                                    <label for="permission_{{ $permission->id }}">
                                    </label>
                                </div>
                            </td>
                        </tr>
                      @endforeach
                  </tbody>
                </table>
              </div>
               <div class="card-footer clearfix">
                   {{ $permissions->links() }}
                  {{-- {{ $cities->render }} --}}
              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
          </div>
        </div>
        <!-- /.row -->
      </div>
    </section>
@endsection

@section('scripts')
    <!-- Toastr -->
    <script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>

    <script>
         function store(adminId,permissionId){
            axios.post('/cms/admins/'+adminId+'/permissions ', {
                // permission_id: document.getElementById ('permission_'+permissionId).value,
                permission_id: permissionId,
            })
            .then(function (response) {
                console.log(response);
                showToaster(response.data.message, true);
            })
            .catch(function (error) {
                console.log(error.response);
                showToaster(error.response.data.message, false);
            });
        }

        function showToaster(message, status){
            if(status){
                toastr.success(message);
            }else{
                toastr.error(message);
            }
        }
    </script>
@endsection

resources/views/cms/admin/index.blade.php
@extends('cms.parent')

@section('title','Admins')
@section('page-name','Index Admins')
@section('main-page','Admins')
@section('sub-page','Index')

@section('styles')
<link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
@endsection

@section('content')
<section class="content">
    <div class="container-fluid">
        <!-- /.row -->
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">Admins</h3>

                        <div class="card-tools">
                            <form role="form"  method="get" action="{{ route('admins.index') }}">

                            <div class="input-group input-group-sm" style="width: 200px;">

                                <input type="text" name="search" value="{{ request()->search }}" id="search"class="form-control float-right"
                                    placeholder="Search">

                                <div class="input-group-append">


                                    <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                                </div>

                            </div>
                        </form>

                        </div>
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body table-responsive p-0">
                        <table class="table table-hover table-bordered text-nowrap">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Name</th>
                                    <th>Email</th>
                                    <th>Mobile</th>
                                    <th>status</th>
                                    <th>Gender</th>
                                    <th>Permissions</th>
                                    <th>Created At</th>
                                    <th>Updated At</th>
                                    <th>Settings</th>
                                </tr>
                            </thead>
                            <tbody>
                                @if($admins->count())
                                    @foreach ($admins as $admin)
                                <tr>
                                    <td>{{ $admin->id }}</td>
                                    <td>{{ $admin->name}}</td>
                                    <td>{{ $admin->email}}</td>
                                    <td>{{ $admin->mobile }}</td>
                                    <td>{{ $admin->status }}</td>
                                    <td><span class="badge bg-success">{{ $admin->gender }}</span></td>
                                    <td><a href="{{ route('admins.permissions.index',$admin->id) }}"
                                            class="btn btn-info">{{ $admin->permissions_count }} / Permissions <i
                                                class="fas fa-user-tie"></i></a></td>
                                    {{-- <td>{{ $admin->city->name }}</td> --}}
                                    <td>{{ $admin->created_at->format('Y-m-d') }}</td>
                                    <td>{{ $admin->updated_at->format('Y-m-d') }}</td>
                                    <td>
                                        <div class="btn-group">
                                            <a href="{{ route('admins.edit',$admin->id) }}" type="button"
                                                class="btn btn-info"><i class="fas fa-edit"></i></a>
                                            {{-- {{-- @if(Auth::user()->id != $admin->id) --}}
                                            <form role="form" class="destroy" method="POST" action="{{ route('admins.destroy',$admin->id) }}">
                                                @csrf
                                                @method('DELETE')
                                                <button type="submit" class="btn btn-danger"><i class="fas fa-trash"></i></button>
                                            </form>

                                            {{-- @endif  --}}
                                        </div>
                                    </td>
                                </tr>
                                @endforeach
                                @else( )
                                <tr>
                                    <td colspan='10'class=text-center >no result</td>
                                </tr>

@endif
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer clearfix">
                        {{ $admins->links() }}
                        {{-- {{ $admins->render }} --}}
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
        </div>
        <!-- /.row -->
    </div>
</section>
@endsection

@section('scripts')
{{-- <script>
    function performDestroy(id, td){
        // confirmDestroy('{{ route('admins.destroy',$admin->id) }}', td)
        axios.delete('{{ route('admins.destroy',$admin->id) }}')
            .then(function (response) {
                console.log(response.data);
                showAlert(response.data);
            })
            .catch(function (error) {
                console.log(error.response);
                showAlert(error.response.data);
            })
            .then(function () {
                // always executed
            });
    }

    function restore(id){

        }
</script> --}}

<script>
// $('#search').submit(function(e){
// e.preventDefault();

// var data = new FormData(this);

// function performStore(){
//     store('route('search')', data)

// }
// });
    $('.destroy').submit(function(e){
        e.preventDefault();
        Swal.fire({
  title: 'Are you sure?',
  text: "You won't be able to revert this!",
  icon: 'warning',
  showCancelButton: true,
  confirmButtonColor: '#3085d6',
  cancelButtonColor: '#d33',
  confirmButtonText: 'Yes, delete it!'
}).then((result) => {
  if (result.isConfirmed) {
    axios.delete($(this).attr('action'))
            .then(function (response) {
                showToaster(response.data.message,'success');
                window.location.reload();
            })
            .catch(function (error) {
                console.log(error)
                showToaster("error hapen",'error');
            })

  }
})
    })
</script>
@endsection